Attribute VB_Name = "modNewsDde"
Option Explicit

Global iDdeTimeout As Integer
Global bDdeNoWarning As Boolean

Global iMode As Integer

Global sCommand As String

Global sApplication As String
Global sTopic As String

Global sDejaNewsURL As String


    Public Const SWP_NOSIZE = &H1
    Public Const SWP_NOMOVE = &H2
    Public Const HWND_TOPMOST = -1
    Public Const HWND_NOTOPMOST = -2
     
#If Win16 Then
    '16bit calls
    
    Public Declare Function GetPrivateProfileString% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName$, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFileName$)
    Public Declare Function GetPrivateProfileInt% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName$, ByVal nDefault%, ByVal lpFileName$)
    Public Declare Function WritePrivateProfileString% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName$, ByVal lpString$, ByVal lpFileName$)
    
    Public Declare Function SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer
    
#Else
    '32bit calls
    
    Public Declare Function GetPrivateProfileString Lib "KERNEL32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
    Public Declare Function GetPrivateProfileInt Lib "KERNEL32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
    Public Declare Function WritePrivateProfileString Lib "KERNEL32" Alias "WritePrivateProfileStringA" (ByVal AppName$, ByVal KeyName$, ByVal keydefault$, ByVal FileName$) As Long
    
    Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

    Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

    Global Const REG_SZ As Long = 1
    Global Const REG_DWORD As Long = 4
     
    Global Const HKEY_CLASSES_ROOT = &H80000000
    Global Const HKEY_CURRENT_USER = &H80000001
    Global Const HKEY_LOCAL_MACHINE = &H80000002
    Global Const HKEY_USERS = &H80000003
     
    Global Const ERROR_NONE = 0
    Global Const ERROR_BADDB = 1
    Global Const ERROR_BADKEY = 2
    Global Const ERROR_CANTOPEN = 3
    Global Const ERROR_CANTREAD = 4
    Global Const ERROR_CANTWRITE = 5
    Global Const ERROR_OUTOFMEMORY = 6
    Global Const ERROR_INVALID_PARAMETER = 7
    Global Const ERROR_ACCESS_DENIED = 8
    Global Const ERROR_INVALID_PARAMETERS = 87
    Global Const ERROR_NO_MORE_ITEMS = 259
     
    Global Const KEY_ALL_ACCESS = &H3F
     
    Global Const REG_OPTION_NON_VOLATILE = 0
     
    Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
    Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
    Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
    Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
    Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
    Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
    Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
    Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long
        
#End If

Function QueryValueEx(ByVal lhKey As Long, ByVal szValueName As String, vValue As Variant) As Long
    
    Dim cch As Long
    Dim lrc As Long
    Dim lType As Long
    Dim lValue As Long
    Dim sValue As String
 
    On Error GoTo QueryValueExError
 
#If Win16 Then
        
#Else

    ' Determine the size and type of data to be read
    lrc = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
    If lrc <> ERROR_NONE Then Error 5
 
    Select Case lType
        ' For strings
        Case REG_SZ:
            sValue = String(cch, 0)
            lrc = RegQueryValueExString(lhKey, szValueName, 0&, lType, sValue, cch)
            If lrc = ERROR_NONE Then
                vValue = Left$(sValue, cch)
            Else
                vValue = Empty
            End If
        ' For DWORDS
        Case REG_DWORD:
            lrc = RegQueryValueExLong(lhKey, szValueName, 0&, lType, lValue, cch)
            If lrc = ERROR_NONE Then vValue = lValue
        
        Case Else
            'all other data types not supported
            lrc = -1
    
    End Select
 
#End If
 
QueryValueExExit:
    QueryValueEx = lrc
    Exit Function

QueryValueExError:
    Resume QueryValueExExit

End Function


Public Function DdeDejaNews(ByVal sCommand As String) As Integer

    Dim hKey As Long
    Dim sKeyName As String
        
    Dim lRetVal As Long
    Dim sValueName As String

    Dim sErrMessage As String
    Dim sQuote As String

    Dim i As Integer

    sQuote = """"   ' sQuote = "

#If Win16 Then

    Const vbLinkManual = 2

#Else
    
    If sApplication = "" Then
        'Set Registry SubKey
        sKeyName = "http\shell\open\ddeexec\application"
        
        sValueName = ""
        
        lRetVal = RegOpenKeyEx(HKEY_CLASSES_ROOT, sKeyName, 0, KEY_ALL_ACCESS, hKey)
        lRetVal = QueryValueEx(hKey, sValueName, sApplication)
        RegCloseKey (hKey)
    
        sApplication = Trim(Left(sApplication, Len(sApplication) - 1))
    
        If sApplication = "NSShell" Then
            sApplication = "Netscape"
        End If
    
    End If
        
#End If

    If sApplication = "" Then
        sApplication = "Netscape"    'defualt Netscape !!
    End If
    
    If InStr(1, sCommand, "news:", 1) Then
        sCommand = Mid$(sCommand, InStr(1, sCommand, "news:", 1) + 5)
    End If
    
    'MsgBox sCommand
    
    For i = Len(sCommand) To 1 Step -1
        Select Case Asc(Mid$(sCommand, i, 1))
            'common (and not so common) exceptions
            Case 33, 36, 45, 46, 64, 95
            'escape non-alphanumeric - definately need to do #=+ and probably others
            Case 0 To 47, 58 To 63, 91 To 96, 123 To 127
                sCommand = Left$(sCommand, i - 1) & "%" & Hex(Asc(Mid$(sCommand, i, 1))) & Mid$(sCommand, i + 1)
            Case Else
                'do nothing
        End Select
    Next i
    
    'MsgBox sCommand
    
    sCommand = Left$(sDejaNewsURL, InStr(sDejaNewsURL, "%1") - 1) & sCommand & Mid$(sDejaNewsURL, InStr(sDejaNewsURL, "%1") + 2)
    
    'MsgBox sCommand
    
    frmNewsDde.txtDdeData.LinkMode = vbLinkNone
    frmNewsDde.txtDdeData.LinkTopic = sApplication & "|" & "WWW_OpenURL"
    frmNewsDde.txtDdeData.LinkItem = sQuote & sCommand & sQuote & ",,0xFFFFFFFF,0x0"
    frmNewsDde.txtDdeData.LinkTimeout = iDdeTimeout
    
On Error GoTo DdeDejaNewsErr
    
    Err.Clear
    
    sErrMessage = "DDE link failed to connect to browser"
    
    frmNewsDde.txtDdeData.LinkMode = vbLinkManual
    
    sErrMessage = "DDE link failed to execute request to browser"
    
    frmNewsDde.txtDdeData.LinkRequest

    frmNewsDde.txtDdeData.LinkMode = vbLinkNone
    frmNewsDde.txtDdeData.LinkTopic = sApplication & "|" & "WWW_Activate"
    frmNewsDde.txtDdeData.LinkItem = "-1,0"
    frmNewsDde.txtDdeData.LinkTimeout = iDdeTimeout
    frmNewsDde.txtDdeData.LinkMode = vbLinkManual
        
    sErrMessage = "DDE link failed to activate browser"
    
    frmNewsDde.txtDdeData.LinkRequest

    Exit Function
    
DdeDejaNewsErr:

    If bDdeNoWarning = False Then
        MsgBox sErrMessage & vbCrLf & "Message #" & Err & vbCrLf & "Message :" & Err.Description
    
        Exit Function
    End If
    
    Err.Clear
    
    Resume Next
    
End Function

Public Sub Main()

    Dim lRetVal As Long

    sCommand = Command
    
    'MsgBox sCommand
    iDdeTimeout = GetPrivateProfileInt("DDE", "Timeout", 50, App.Path & "\" & App.EXEName & ".INI")
    bDdeNoWarning = GetPrivateProfileInt("DDE", "NoWarning", 0, App.Path & "\" & App.EXEName & ".INI")

    iMode = GetPrivateProfileInt("DDE", "Mode", 3, App.Path & "\" & App.EXEName & ".INI")

    '--
    sApplication = Space(512)
    lRetVal = GetPrivateProfileString("DDE", "Application", "", sApplication, Len(sApplication), App.Path & "\" & App.EXEName & ".INI")
    sApplication = Trim(Left(sApplication, lRetVal))
        
    sDejaNewsURL = Space(512)
    lRetVal = GetPrivateProfileString("DDE", "DejaNewsURL", "", sDejaNewsURL, Len(sDejaNewsURL), App.Path & "\" & App.EXEName & ".INI")
    sDejaNewsURL = Trim(Left(sDejaNewsURL, lRetVal))
    
    If sDejaNewsURL = "" Then
        sDejaNewsURL = "http://search.dejanews.com/msgid.xp?MID=<%1>"
    End If
    
    If InStr(sDejaNewsURL, "%1") = 0 Then
        sDejaNewsURL = sDejaNewsURL & "%1"
    End If
    
    If sCommand = "" Then
        frmNewsDde.Show vbModal
    Else
        
        If iMode = 0 Then
            frmNewsDdeAsk.Show vbModal
        ElseIf iMode = 1 Then
            Call DdeAgent(sCommand)
        ElseIf iMode = 2 Then
            Call DdeDejaNews(sCommand)
        ElseIf iMode = 3 Then
            Call DdeAgent(sCommand)
            Call DdeDejaNews(sCommand)
        ElseIf iMode = 4 Then
            Call DdeDejaNews(sCommand)
            Call DdeAgent(sCommand)
        End If
    
    End If
    
    End

End Sub


Public Function DdeAgent(ByVal sCommand As String) As Integer

    Dim sErrMessage As String

    'search Agent (unfortunatly only the instance setup for news - not necessarily the current instance)
    
    frmNewsDde.txtDdeData.LinkMode = vbLinkNone
    frmNewsDde.txtDdeData.LinkTopic = "ForteAgent" & "|" & "news"
    frmNewsDde.txtDdeData.LinkItem = ""
    frmNewsDde.txtDdeData.LinkTimeout = iDdeTimeout
    
On Error GoTo DdeAgentErr
    
    Err.Clear
    
    sErrMessage = "DDE link failed to connect to Agent"
    
    frmNewsDde.txtDdeData.LinkMode = vbLinkManual
        
    'MsgBox "Agent " & sCommand
    
    sErrMessage = "DDE link failed to execute Agent"
    
    frmNewsDde.txtDdeData.LinkExecute "URL " & sCommand

    Exit Function

DdeAgentErr:

    If bDdeNoWarning = False Then
        MsgBox sErrMessage & vbCrLf & "Message #" & Err & vbCrLf & "Message :" & Err.Description
        
        Exit Function
    End If
    
    Err.Clear
    
    Resume Next

End Function
